#include "cEnemy.h"


// Constructor and destructor
cEnemy::cEnemy(void)
{
	add_value = 0;
	
	inix=0.0f;
	iniy=0.0f;
	endx=0.2f;
	endy=0.1f;
	add_value=1;
	enemy_delay=0;
	prev_map_pos=0;
	enable = ENEMY_ENABLE;
	direction = DIR_RIGHT;
}

cEnemy::cEnemy(int _addValue,int _enemyType,int _posx, int _posy)
{
	add_value = _addValue;
	pTexture = auto_ptr<cTexture> (new cTexture());
	pTexture->Load("img/skeleton.png",GL_RGBA);	
	posx=_posx;
	posy=_posy;
	initialposx=posx;	
	inix=0.4f;
	iniy=0.2f;
	endx=0.52f;
	endy=0.34;
	enemy_delay=0;
	prev_map_pos=0;
	enable = ENEMY_ENABLE;
	direction = DIR_RIGHT;
}

cEnemy::~cEnemy(void)
{
}


void cEnemy::moveRigth(const cMap * _map)
{	
	if (prev_map_pos !=_map->getCoordX())
	{		
		posx +=  _map->getCoordX() - prev_map_pos;
		prev_map_pos =_map->getCoordX();
	}	
	
}	

void cEnemy::moveLeft(const cMap * _map)
{
	if (prev_map_pos !=_map->getCoordX())
	{		
		posx +=  _map->getCoordX() - prev_map_pos;
		prev_map_pos =_map->getCoordX();
	}
}	

bool cEnemy::collidesMapFloor(const cMap * _map)
{
	int pos_tile_x,pos_tile_y;

	// Take the relative tile size position 
	pos_tile_x = (posx - _map->getCoordX()) / TILE_SIZE; 
	pos_tile_y = (posy-1) / TILE_SIZE;// -1 to check the next tile (under the heroe foods)
		
	// Check
	if (_map->getMapPos(pos_tile_x,pos_tile_y)!= 0 ) 	
	{
		return true;
	}
	else
	{
		return false;
	}
}

bool cEnemy::collidesMapWall(const cMap * _map)
{
	int pos_tile_x,pos_tile_y;

	// Take the relative tile size position 
	pos_tile_x = (posx - _map->getCoordX()) / TILE_SIZE; 
	pos_tile_y = posy / TILE_SIZE;
	

	// If right we want to check the next one, if left the previous one
	if(direction==DIR_RIGHT) 
	{
		pos_tile_x += 1;
	}
	
	// Check
	if (_map->getMapPos( pos_tile_x,pos_tile_y )!= 0 )
	{
		return true;	
	}
	else 
	{
		return false;	
	}
}

void cEnemy::logic(const cMap * _map)
{	
	if (enable == ENEMY_ENABLE)
	{
		if(enemy_delay== ENEMY_DELAY)
		{
			enemy_delay=0;
			// check the collides with the floor
			if(!collidesMapFloor(_map))		
			{
				posy--;
			}
			else
			{
				if(!collidesMapWall(_map))
				{
					if (direction==DIR_RIGHT)
					{
						posx ++;
					}
					else
					{
						posx --;
					}
				}
				else
				{
					if(direction==DIR_RIGHT)
					{
						direction=DIR_LEFT;
					}
					else
					{
						direction=DIR_RIGHT;
					}
				}
			}

			// check the collides with the map
		}
		else
		{
			enemy_delay++;
		}
	}
}	

cTexture* cEnemy::getTextureEnemy() const
{
	return pTexture.get();		
}

int cEnemy::getRelativePosx(int mapx) const
{
	return posx-mapx;
}
int cEnemy::getRelativePosy(void) const
{
	return posy;
} 
int cEnemy::getEnable(void) const
{
	return enable;
}
int cEnemy::getAddValue() const
{
	return add_value;
}
float cEnemy::getEndx() const
{
	return endx;
}
float cEnemy::getEndy() const
{
	return endy;
}
float cEnemy::getInix() const
{
	return inix;
}
float cEnemy::getIniy() const
{
	return iniy;
}
int cEnemy::getPosx() const
{
	return posx;
}
int cEnemy::getPosy() const
{
	return posy;
}
int cEnemy::getEnemyTileSize() const
{
	return ENEMY_SIZE;
}