#include "cGameCore.h"

// Singleton instance
cGameCore* cGameCore::instance = NULL;

// Singleton implementation
cGameCore *cGameCore::getInstance()
{	
	if (instance == NULL)
	{
		instance = new cGameCore();
	}
    return instance;
}


cGameCore::cGameCore()
{	
}

cGameCore::~cGameCore()
{
}

void cGameCore::InitializeGameComponents(const int _playerType)
{
	// Initialize smart pointers
	pPlayer		=  auto_ptr <cPlayer>(new cPlayer(_playerType));
	pScene		=  auto_ptr <cScene> (new cScene());	
	pFileLoader =  auto_ptr <cFileLoader> (new cFileLoader());

	// Scene initialization
	pScene->Initialize();
	
	// Load level data
	pFileLoader->loadLevelData(LEVEL_DATA_01);
}

cPlayer * cGameCore::getPlayer() const
{
	return pPlayer.get();
}

cScene * cGameCore::getScene() const
{
	return pScene.get();
}
