#include "cItem.h"


cItem::cItem()
{
	add_value = 0;
	item_type = ITEM_TYPE_LIVE;
	inix=0.0f;
	iniy=0.0f;
	endx=0.2f;
	endy=0.1f;
	add_value=1;
	item_delay=0;
	prev_map_pos=0;
	enable = ITEM_ENABLE;
}

cItem::cItem(int _addValue,int _itemType,int _posx, int _posy)
{
	add_value = _addValue;
	pTexture = auto_ptr<cTexture> (new cTexture());
	pTexture->Load("img/items.png",GL_RGBA);
	item_type=_itemType;
	posx=_posx;
	posy=_posy;
	initialposx=_posx;	
	inix=0.0f;
	iniy=0.0f;
	endx=0.2f;
	endy=0.25f;
	item_delay=0;
	prev_map_pos=0;
	enable = ITEM_ENABLE;
}

cItem::~cItem(void)
{
}


void cItem::moveRigth(cMap * _map)
{	
	if (prev_map_pos !=_map->getCoordX())
	{		
		posx += _map->getCoordX() - prev_map_pos;
		prev_map_pos = _map->getCoordX();
	}	
	
}	

void cItem::moveLeft(cMap * _map)
{
	if (prev_map_pos !=_map->getCoordX())
	{		
		posx +=  _map->getCoordX() - prev_map_pos;
		prev_map_pos =_map->getCoordX();
	}
}	

bool cItem::collidesMapFloor(cMap * _map)
{
	int pos_tile_x,pos_tile_y;

	// Take the relative tile size position 
	pos_tile_x = initialposx / TILE_SIZE; 
	pos_tile_y = (posy-1) / TILE_SIZE;// -1 to check the next tile (under the heroe foods)
		
	// Check
	if (_map->getMapPos(pos_tile_x,pos_tile_y)!= 0 )
	{
		return true;
	}
	else 
	{
		return false;
	}
}


void cItem::logic(cMap * _map)
{	
	if(item_delay== ITEM_DELAY)
	{
		item_delay=0;
		if(!collidesMapFloor(_map))		
			posy--;
	}
	else
	{
		item_delay++;
	}
}	

//Getters and setters
void cItem::setEnable(int _enable)
{
	enable=enable;
}

cTexture* cItem::getTextureItem() const
{
	return pTexture.get();		
}
void cItem::setAddAalue(int _addValue)
{
	add_value=add_value;
}

int cItem::getRelativePosx() const
{
	return initialposx;
}
int cItem::getRelativePosy(void) const
{
	return posy;
} 
int cItem::getEnable() const
{
	return enable;
}
int cItem::getAddValue() const
{
	return add_value;
}
float cItem::getEndx() const
{
	return endx;
}
float cItem::getEndy() const
{
	return endy;
}
float cItem::getInix() const
{
	return inix;
}
float cItem::getIniy() const
{
	return iniy;
}
int cItem::getPosx() const
{
	return posx;
}
int cItem::getPosy() const
{
	return posy;
}
int cItem::getItemTileSize() const
{
	return ITEM_SIZE;
}