#include "cMap.h"


cMap::cMap()
{
		sTtextureFile = "img/map.png"; // TBD: remove hardcoded parameter
		iCoordX = 0;
		iCoordY = 0;
		pTexture = auto_ptr <cTexture> (new cTexture());

		// Clouds
		tiles[0]=new cTile(0.f,0.f,0.f,0.f);
		tiles[1]=new cTile(0.201f,0.264f,0.34f,0.395f);
		tiles[2]=new cTile(0.267f,0.330f,0.34f,0.395f);
		tiles[3]=new cTile(0.334f,0.396f,0.34f,0.395f);
		tiles[4]=new cTile(0.401f,0.463f,0.34f,0.395f);
		tiles[5]=new cTile(0.467f,0.529f,0.34f,0.395f);
		tiles[6]=new cTile(0.533f,0.595f,0.34f,0.395f);
		tiles[7]=new cTile(0.599f,0.661f,0.34f,0.395f);
		tiles[8]=new cTile(0.666f,0.724f,0.34f,0.395f);
		
		// Floor	
		tiles[9]=new cTile(0.201f,0.264f,0.41f,0.465f);		//Stone tile		
		tiles[10]=new cTile(0.201f,0.264f,0.005f,0.067f);	// Ground tile
		tiles[11]=new cTile(0.201f,0.264f,0.41f,0.465f);	//Stone tile		
		tiles[12]=new cTile(0.201f,0.264f,0.005f,0.067f);	// Ground tile

		// Gras
		tiles[13]=new cTile(0.334f,0.396f,0.08f,0.13f);
		tiles[14]=new cTile(0.401f,0.463f,0.08f,0.13f);
		tiles[15]=new cTile(0.467f,0.529f,0.08f,0.13f);
		tiles[16]=new cTile(0.533f,0.595f,0.08f,0.13f);
		tiles[17]=new cTile(0.599f,0.661f,0.08f,0.13f);
		tiles[18]=new cTile(0.666f,0.724f,0.08f,0.13f);
		
		// Dragon
		tiles[19]=new cTile(0.0f,0.24f,0.75f,0.84f,true);	
		tiles[19]->setTiles(0.24f,0.49f,0.75f,0.84f);	
		tiles[19]->setTiles(0.49f,0.73f,0.75f,0.84f);	
		tiles[19]->setTiles(0.73f,0.97f,0.75f,0.84f);			
}

cMap::~cMap()
{
}

bool cMap::isBack(const int _posx, const int _posy)
{
	if (map[_posx][_posy]==0)
	{
		return true;
	}
	else
	{
		return false;
	}
}

bool cMap::loadMap()
{
	return (loadMap(sTtextureFile));

}

bool cMap::loadMap (const string _sFileName)
{
	return false;
}

bool cMap::loadTexture()
{
	pTexture->Load(sTtextureFile.c_str(),GL_RGBA);
		return true;
}

int cMap::getCoordX() const
{
	return iCoordX;
}
int cMap::getCoordY() const
{
	return iCoordY;
}
void cMap::setMapPos(const int _value,const int _posx,const int _posy)
{
	map[_posx][_posy]=_value;
}

void cMap::setCoordX(const int _coordX)
{
	iCoordX=_coordX;
}

int cMap::getMapPos(const int _posx, const int _posy) const
{
	return map[_posx][_posy];
}

cTile * cMap::getTile(const int _pos) const
{
	return tiles[_pos];
}
cTexture* cMap::getTexture() const
{
	return pTexture.get();
}
