//
//
//		Name:		cMap.h
//		Date:		01-02-2009
//		Author:		Alejandro Santiago
//		Email:		alejandro@aeonphyxius.com
//		Desc:		Map class. To manage how to load the different tile maps 
//					an the logic to draw the level's map
//
//

#ifndef __MAP_H__
#define __MAP_H__

#include "cTile.h"
#include "cTexture.h"
#include "globals.h"


class cMap
{
private: // Class variables
		
	int iMapHeight, iMapWidth;				// Maps's width and Height	
	int iSceneWidth,iSceneHeight;			// Visible's area Width and Height 	
	int iCoordX, iCoordY;					// Visible area coordinates
	int map[165][15];						// matrix containing the map // TBD: make it longer and resizebla	
	cTile *tiles[21];						// Tiles that compose the map	
	string sTtextureFile;					// Tiles Texture image filename		
	auto_ptr<cTexture> pTexture;			// Tiles textures image

public:

	cMap();
	cMap(int _mapHeight, int _mapWidth,int _sceneWidth,int _sceneHeight);
	~cMap();

	/**
	* Loads the map using the default configuration file
	*	
	* @return true if the loading process have been done correctly
    */
	bool loadMap();

	/**
	* Loads the map using given configuration file
	*
	* @param _sFileName file containing the configuration for this map
	* @return true if the loading process have been done correctly
    */
	bool loadMap(const string _sFileName);

	/**
	* Loads the default texture file
	*	
	* @return true if the loading process have been done correctly
    */
	bool loadTexture();

	// Setters	
	void setCoordX(const int _coordX);
	void setMapPos(const int _value,const int _posx,const int _posy);

	// Getters
	int getCoordX() const;
	int getCoordY() const;
	char * getTexture_file() const;
	cTexture* getTexture() const;
	int getMapPos(const int _posx, const int _posy) const;
	cTile* getTile(const int _pos) const;
	bool isBack(const int _posx, const int _posy);

};

#endif  // __MAP_H__