#include "cTexture.h"
#include "corona.h"

cTexture::cTexture(void)
{
	width = 0;
	height = 0;
	id = 0;
}

cTexture::~cTexture(void)
{
}

bool cTexture::Load(const char * _filename,int _type, int _wraps, int _wrapt, int _magf, int _minf, bool _mipmap)
{
	corona::Image* img;
	int components;

	img = corona::OpenImage(_filename);
	if(_type==GL_RGB)		components = 3;
	else if(_type==GL_RGBA)	components = 4;
	else return false;

	if(img==NULL) return false;

	width  = img->getWidth();
	height = img->getHeight();

	glGenTextures(1, &id);
	glBindTexture(GL_TEXTURE_2D,id);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,_wraps);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,_wrapt);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,_magf);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,_minf);

	if(!_mipmap)
	{
		glTexImage2D(GL_TEXTURE_2D,0,components,width,height,0,_type,
					 GL_UNSIGNED_BYTE,img->getPixels());
	}
	else
	{
		gluBuild2DMipmaps(GL_TEXTURE_2D,components,width,height,_type,
						  GL_UNSIGNED_BYTE,img->getPixels());
	}
	return true;
}
int cTexture::GetID()
{
	return id;
}

void cTexture:: GetSize(int *_w, int *_h)const
{
	*_w = width;
	*_h = height;
}