//
//
//		Name:		cTexture.h
//		Date:		01-02-2009
//		Author:		Alejandro Santiago
//		Email:		alejandro@aeonphyxius.com
//		Desc:		Class manipulate each Texture image for the different items
//
//
#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#pragma comment(lib,"corona")

#include "globals.h"


class cTexture
{
private: // Class variables
	GLuint id;				// Texture image bind id
	int width;				// Texture widh
	int height;				// Texture height
public:
	cTexture();
	~cTexture();

	/**
    * Load the image that would be bind on this texture
	* 
	* @param _filename image file name
	* @param _type tipe of file (jpg, png, ...)
	* @param _wraps	
	* @param _wrapt
	* @param _magf
	* @param _minf
	* @param _mipmap
    */
	bool Load(const char * _filename,int _type,int _wraps = GL_REPEAT,int _wrapt = GL_REPEAT,int _magf = GL_NEAREST,int _minf = GL_NEAREST,bool _mipmap = false);
	
	/**
    * Gets the Bind image id	
	*
	* @return image id
    */
	int  GetID();
	
	/**
    * Using the parameters, returns the texture image width and heigh
	* 
	* @param _w image width
	* @param _h image height
	*
	*/
	void GetSize(int * _w, int * _h)const;

};

#endif  // __TEXTURE_H__