#include "cTile.h"


cTile::cTile()
{
	fTileXmin[0]=0.f; 
	fTileXmax[1]=0.f;
	fTileXmin[2]=0.f;
	fTileXmin[3]=0.f;	
	
	fTileXmax[0]=0.f;
	fTileXmax[1]=0.f;
	fTileXmax[2]=0.f;
	fTileXmax[3]=0.f;

	fTileYmin[0]=0.f;
	fTileYmin[1]=0.f;
	fTileYmin[2]=0.f;
	fTileYmin[3]=0.f;
	
	fTileYmax[0]=0.f;
	fTileYmax[1]=0.f;
	fTileYmax[2]=0.f;
	fTileYmax[3]=0.f;
	
	iTileAnimation=0;	
}

cTile::cTile(const float _tileXmin,const float _tileXmax,const float _tileYmin,const float _tileYmax)
{
	
	fTileXmin[0]= _tileXmin;
	fTileXmax[0]= _tileXmax;
	fTileYmin[0]= _tileYmin;
	fTileYmax[0]= _tileYmax;
	iTileAnimation = 0;
	isAnimated = false;
}
cTile::cTile(const float _tileXmin,const float _tileXmax,const float _tileYmin,const float _tileYmax,const bool _isAnimated)
{
	fTileXmin[0]= _tileXmin;
	fTileXmax[0]= _tileXmax;
	fTileYmin[0]= _tileYmin;
	fTileYmax[0]= _tileYmax;
	iTileAnimation = 0;
	iTileDelay=0;
	isAnimated = _isAnimated;
}


cTile::~cTile()
{

}
void cTile::increaseAnimation()
{
	iTileDelay++;
	if(iTileDelay== TILE_DELAY)
	{
		if (iTileAnimation==3)
		{
			iTileAnimation=0;
		}
		else
		{
			iTileAnimation++;
		}
		iTileDelay=0;
	}
}

void cTile::setTiles(const float _tileXmin,const float _tileXmax,const float _tileYmin,const float _tileYmax)
{
	iTileAnimation++;	
	fTileXmin[iTileAnimation] = _tileXmin;
	fTileXmax[iTileAnimation] = _tileXmax;	
	fTileYmin[iTileAnimation] = _tileYmin;
	fTileYmax[iTileAnimation] = _tileYmax;
}

bool cTile::IsAnimated(void)  const
{
	return isAnimated;
}
 
float cTile::getTileXmax(void) 
{
	if (isAnimated)
	{
		increaseAnimation();
		return fTileXmax[iTileAnimation];

	}
	else
	{
		return fTileXmax[0];
	}
}
float cTile::getTileXmin(void)  const
{
	if (isAnimated)	
	{
		return fTileXmin[iTileAnimation];	
	}
	else
	{
		return fTileXmin[0];
	}
}
float cTile::getTileYmax(void) const
{
	if (isAnimated)
	{
		return fTileYmax[iTileAnimation];
	}
	else
	{
		return fTileYmax[0];
	}
}
float cTile::getTileYmin(void)  const
{
	if (isAnimated)
	{
		return fTileYmin[iTileAnimation];
	}
	else
	{
		return fTileYmin[0];
	}
}