//
//
//		Name:		cTile.h
//		Date:		01-02-2009
//		Author:		Alejandro Santiago
//		Email:		alejandro@aeonphyxius.com
//		Desc:		Tiles to design the screen's map. Every Tile
//					is an independant object, including animation tiles
//
//

#ifndef __TILE_H__
#define __TILE_H__

#define TILE_DELAY 3000

class cTile
{

private: // Class variables

	float	fTileXmin[5];			//
	float	fTileXmax[5];			//
	float	fTileYmin[5];			//
	float	fTileYmax[5];			//
	int		iTileAnimation;			// Animation position in animated tile only
	bool	isAnimated;				// Is it an animated tile?
	int		iTileDelay;				// Delay between the animation when animated tile

public:
	cTile(void);
	cTile(const float tile_xmin,const  float tile_xmax,const float tile_ymin,const float tile_ymax);
	cTile(const float tile_xmin,const float tile_xmax,const float tile_ymin,const float tile_ymax,const bool is_animated);
	~cTile(void);

	/**
	* Increases the current animation frame. In case is 4, start over again
	*
    */
	void increaseAnimation(void);

	/**
	* Set the tiles for our animation frame.
	*
	* @param _tileXmin
	* @param _tileXmax
	* @param _tileYmin
	* @param _tileYmax
    */
	void setTiles(const float _tileXmin,const float _tileXmax,const float _tileYmin,const float _tileYmax);
	
	// Getters
	float getTileXmax(); // This method is not const on porpuse. It changes some information depending on the current values
	float getTileXmin() const;
	float getTileYmax() const;
	float getTileYmin() const;
	bool IsAnimated() const;
};

#endif  // __TILE_H__