#include <windows.h>
#include "cGame.h"
#include "globals.h"

//Delete console
#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")


void AppRender()
{
	cGame::getInstance()->Render();
}
void AppKeyboard(unsigned char key, int x, int y)
{
	cGame::getInstance()->ReadKeyboard(key,x,y,true);
}
void AppKeyboardUp(unsigned char key, int x, int y)
{
	cGame::getInstance()->ReadKeyboard(key,x,y,false);
}
void AppSpecialKeys(int key, int x, int y)
{
	cGame::getInstance()->ReadKeyboard(key,x,y,true);
}
void AppSpecialKeysUp(int key, int x, int y)
{
	cGame::getInstance()->ReadKeyboard(key,x,y,false);
}
void AppMouse(int button, int state, int x, int y)
{
	cGame::getInstance()->ReadMouse(button,state,x,y);
}
void AppIdle()
{
	if(!cGame::getInstance()->Loop()) 
	{
		exit(0);
	}
}

// Entry point of the App
void main(int argc, char** argv)
{
	cGameCore::getInstance()->InitializeGameComponents(PLAYER_TYPE_AX);	
	
	int res_x,res_y,pos_x,pos_y;
	

	//GLUT initialization
	glutInit(&argc, argv);

	//RGBA with double buffer
	glutInitDisplayMode(GLUT_RGBA | GLUT_ALPHA | GLUT_DOUBLE);

	//Create centered window
	res_x = glutGet(GLUT_SCREEN_WIDTH);
	res_y = glutGet(GLUT_SCREEN_HEIGHT);
	pos_x = (res_x>>1)-(GAME_WIDTH>>1);
	pos_y = (res_y>>1)-(GAME_HEIGHT>>1);
	
	glutInitWindowPosition(pos_x,pos_y);
	glutInitWindowSize(GAME_WIDTH,GAME_HEIGHT);
	glutCreateWindow("Golden Axe Returns :)");

	//glutGameModeString("800x600:32");
	//glutEnterGameMode();

	//Make the default cursor disappear
	glutSetCursor(GLUT_CURSOR_NONE);

	//Register callback functions
	glutDisplayFunc(AppRender);			
	glutKeyboardFunc(AppKeyboard);		
	glutKeyboardUpFunc(AppKeyboardUp);	
	glutSpecialFunc(AppSpecialKeys);	
	glutSpecialUpFunc(AppSpecialKeysUp);
	glutMouseFunc(AppMouse);
	glutIdleFunc(AppIdle);

	//Game initializations
	cGame::getInstance()->Initialize();

	//Application loop
	glutMainLoop();	
}
